/*
 * Reveal | tutorial.js
 * Copyright 2006 by Michael Wu
 * Released under GPL v2
 */

var RTutorial = {
	running: false,
	slides: new Array(),
	current_slide: -1,

	changeListener: function (event)
	{
		RTutorial.nextSlide();
	},

	loadSlide: function (slide)
	{
		var box = document.getElementById("rtut-box");
		box.style.display = "none";
		if (box.firstChild.childNodes.length > 1) {
			var oldslide = box.firstChild.childNodes[1];
			box.firstChild.removeChild(oldslide);
			var watch;
			if (oldslide.hasAttribute("watch")) {
				watch = oldslide.getAttribute("watch");
				document.getElementById(watch).removeEventListener("DOMAttrModified", this.changeListener, false);
			}
			if (oldslide.hasAttribute("watchtyping")) {
				watch = oldslide.getAttribute("watchtyping");
				document.getElementById(watch).removeEventListener("input", this.changeListener, false);
			}
		}

		if (!this.running)
			return;

		var mwindow = document.getElementById("main-window");
		slide.firstChild.style.maxWidth = (mwindow.boxObject.width*.6) + "px";
		box.firstChild.appendChild(slide);
		if (slide.hasAttribute("loadrun"))
			eval(slide.getAttribute("loadrun"));

		if (slide.hasAttribute("watch"))
			document.getElementById(slide.getAttribute("watch")).addEventListener("DOMAttrModified", this.changeListener, false);

		if (slide.hasAttribute("watchtyping"))
			document.getElementById(slide.getAttribute("watchtyping")).addEventListener("input", this.changeListener, false);

		slide.style.margin = "2px";
		var label = document.getElementById("rtut-title");
		label.setAttribute("value", slide.getAttribute("title"));
		switch (slide.getAttribute("align")) {
		case "center":
			box.style.top = "25%";
			box.style.left = "25%";
			box.style.right = "";
			box.style.bottom = "";
			box.style.display = "-moz-popup";
			var left, top;
			left = (mwindow.boxObject.width - box.boxObject.width)/2;
			top = (mwindow.boxObject.height - box.boxObject.height)/2;
			box.style.top = top + "px";
			box.style.left = left + "px";
			break;
		case "corner":
			box.style.top = "";
			box.style.left = "";
			box.style.right = "5%";
			box.style.bottom = "15%";
			box.style.display = "-moz-popup";
			break;
		}

		this.current_slide = this.slides.indexOf(slide);
	},

	nextSlide: function ()
	{
		this.loadSlide(this.slides[this.current_slide + 1]);
	},

	// switching tabs can obscure our box, so we need to push it
	// to the front when this happens
	redraw: function (event)
	{
		var mwindow = document.getElementById("main-window");
		var box = document.getElementById("rtut-box");
		mwindow.removeChild(box);
		mwindow.appendChild(box);
	},

	updateSlide: function (event)
	{
		if (RTutorial.current_slide == -1)
			return;

		var mwindow = document.getElementById("main-window");
		var slide = RTutorial.slides[RTutorial.current_slide];
		slide.firstChild.style.maxWidth = (mwindow.boxObject.width*.6) + "px";

		if (slide.getAttribute("align") != "center")
			return;

		var box = document.getElementById("rtut-box");
		var left, top;
		left = (mwindow.boxObject.width - box.boxObject.width)/2;
		top = (mwindow.boxObject.height - box.boxObject.height)/2;
		box.style.top = top + "px";
		box.style.left = left + "px";
	},

	start: function ()
	{
		if (this.running)
			return;

		this.running = true;
		var nl = document.getElementById("rtut-bin").childNodes;
		var i;
		for (i in nl)
			this.slides.push(nl[i]);

		getBrowser().addEventListener("select", this.redraw, false)
		this.loadSlide(this.slides[0]);
		window.addEventListener("resize", this.updateSlide, false);
	},

	stop: function ()
	{
		if (!this.running)
			return;

		this.running = false;

		getBrowser().removeEventListener("select", this.redraw, false)
		document.getElementById("rtut-box").style.display = "none";
		this.loadSlide(null);
		window.removeEventListener("resize", this.updateSlide, false);
	},

	onLoad: function ()
	{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("reveal.");
		if (prefs.getBoolPref("firstrun")) {
			prefs.setBoolPref("firstrun", false);
			setTimeout("RTutorial.start();", 500);
		}
	}
};

window.addEventListener("load", function(e) { RTutorial.onLoad(); }, false);
